<link rel="import" href="../polymer/polymer-element.html" />

<dom-module id="dispatch-event-element">
    <template>
        <style>
            :host {
                display: block;
            }
        </style>
        <h2>Hello [[prop1]]!</h2>
        <button on-click="handleClick">Lanzar evento</button>
    </template>

    <script>
        /**
         * `dispatch-event-element`
         * hgfd
         *
         * @customElement
         * @polymer
         * @demo demo/index.html
         */
        class DispatchEventElement extends Polymer.Element {
            constructor() {
                super();
                this.addEventListener("myEvent", (e) => {
                    console.log(e.detail.data, Date.now(), "self");
                });
            }
            static get is() {
                return "dispatch-event-element";
            }
            static get properties() {
                return {
                    prop1: {
                        type: String,
                        value: "dispatch-event-element",
                    },
                };
            }
            handleClick(e) {
                this.dispatchEvent(
                    new CustomEvent("myEvent", {
                        detail: {
                            data: true,
                        },
                    })
                );
            }
        }

        window.customElements.define(DispatchEventElement.is, DispatchEventElement);
    </script>
</dom-module>
